=== debian/changelog ===
pandora (0.7.1-0ubuntu3) saucy; urgency=low

  * debian/compat: Bump to 9.
  * debian/control:
    - Remove cdbs from Build-Depends.
    - Bump debhelper Build-Depends to (>= 9).
    - Bump Standards-Version to 3.9.4.
    - Add ${misc:Depends} to binary.
  * debian/patches/*: Convert to quilt.
  * debian/rules: Convert to dh sequencer.
  * debian/source/format: Indicate 3.0 (quilt) format.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 09 Jun 2013 19:49:47 -0400

pandora (0.7.1-0ubuntu2) gutsy; urgency=low

  * debian/control: Update maintainer fields according to debian-
    maintainer-field spec.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 15 Aug 2007 08:09:25 +0000

pandora (0.7.1-0ubuntu1) dapper; urgency=low

  * Initial release
  * Added patches/01_makefile.diff to patch the Makefile

 -- Hubert Figuiere <hub@figuiere.net>  Wed, 22 Feb 2006 12:57:17 -0500
