=== debian/control ===
Source: pandora
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Hubert Figuiere <hub@figuiere.net>
Build-Depends: debhelper (>= 9), libgimp2.0-dev
Standards-Version: 3.9.4
Homepage: http://www.shallowsky.com/software/pandora/

Package: pandora
Architecture: any
Depends: ${misc:Depends}, gimp (>= 2.0)
Description: GIMP Plugin For Creating Panoramas
 GIMP Plugin that arranges images for creation of
 panoramic images.  Pandora uses gradients, and 
 overlays to blend the images, allowing a seamless
 appearance.
