## pandora box-0.15.0

=== Makefile ===
--- 
+++ 
@@ -45,8 +45,11 @@
 
 export RUST_BACKTRACE=1
 
+# Pick number of jobs based on CPU count
+JOBS = $(shell nproc)
+
 # Cargo features and flags
-CARGOFLAGS= -j$(shell nproc) --quiet
+CARGOFLAGS= -j$(JOBS) --quiet
 CARGOFEATS= uring
 # CARGONODEF=YesPlease -> CARGOFLAGS+=--no-default-features
 ifneq ($(CARGONODEF),)
@@ -77,7 +80,6 @@
 	  syd-ldd \
 	  syd-load \
 	  syd-lock \
-	  syd-log \
 	  syd-ls \
 	  syd-mdwe \
 	  syd-net \
@@ -127,7 +129,6 @@
        man/syd-ldd.1 \
        man/syd-load.1 \
        man/syd-lock.1 \
-       man/syd-log.1 \
        man/syd-ls.1 \
        man/syd-mdwe.1 \
        man/syd-net.1 \
@@ -280,6 +281,8 @@
 release:
 	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
 	$(CARGO) build --release --locked --features $(CARGOFEATS) $(CARGOFLAGS) $(TARGET)
+nopie:
+	env RUSTFLAGS="$(RUSTFLAGS) -g -Ctarget-cpu=native -Clink-arg=-no-pie" $(MAKE) release
 prof:
 	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
 	env RUSTFLAGS='-g -Ctarget-cpu=native -Ctarget-feature=-crt-static' \
@@ -386,6 +389,14 @@
 who:
 	@git log --all --format='%cN <%cE>' | sort -u
 
+cross: cross-mips64el
+
+cross-mips64el:
+	env CROSS_CONTAINER_ENGINE=podman \
+		cross build -j$(JOBS) --release \
+			--target mips64el-unknown-linux-muslabi64 \
+			-Z build-std=std,panic_abort -Zbuild-std-features=panic_immediate_abort
+
 root: alpine-rootfs.tar.gz
 	mkdir -p -m700 $@
 	doas tar -C $@ -xpf alpine-rootfs.tar.gz
@@ -414,13 +425,3 @@
 # XXX: This won't work, instead
 # 1. Pull cosmopolitan.git
 # 2. Build with: build/bootstrap/make -j4 m=optlinux o/optlinux/libc
-# 3. Create libc.a with: cd o/optlinux/libc && ar rcs libc.a $(find . -type f -name "*.o")
-# 4. Place libc.a under libc/$ARCH-linux-cosmo/lib
-libcosmo:
-	/bin/sh -exc " \
-		rm -rf libcosmo; \
-		mkdir -m700 libcosmo; \
-		cd libcosmo; \
-		wget https://justine.lol/cosmopolitan/cosmopolitan.zip; \
-		unzip cosmopolitan.zip; \
-		rm -f cosmopolitan.zip; \
