## pandora box-0.19.0-crates

=== gentoo/lexis-0.2.3/Makefile ===
# lexis' Makefile
# Copyright (c) 2024 Ali Polatel <alip@chesswob.org>
# SPDX-License-Identifier: GPL-3.0-or-later

CARGO= cargo

# Cargo features and flags
CARGOFLAGS= -j$(shell nproc) -v

all: build

build:
	$(CARGO) deny check
	$(CARGO) clippy $(CARGOFLAGS)
	$(CARGO) build --locked $(CARGOFLAGS)
	$(CARGO) test
fmt:
	$(CARGO) fmt
lint:
	$(CARGO) clippy $(CARGOFLAGS)

.PHONY: all build fmt lint
